"""ListboxTest.py   Test the Listbox widget with event handling"""

from Tkinter import *

class Application(Frame):
    def __init__(self, master=None):
        Frame.__init__(self, master)
        self.master.title("Listbox Test")
        self.grid()
        self._createWidgets()

    def _createWidgets(self):
        prompt = Label(self, text="Select your favorite animals (select all \                                that apply):")
        prompt.grid(row=0, sticky=W+E)
        yScroll = Scrollbar(self, orient=VERTICAL)
        yScroll.grid(row=1, column=1,sticky=N+S)

        xScroll = Scrollbar(self, orient=HORIZONTAL)
        xScroll.grid(row=2, column=0,sticky=E+W)

        self._myListbox = Listbox(self, xscrollcommand=xScroll.set,
                                 yscrollcommand=yScroll.set,
                                 selectmode=MULTIPLE)
        
        self._myListbox.grid(row=1, column=0, sticky=N+S+E+W)
        self._myListbox.insert(END, 'cat')
        self._myListbox.insert(END, 'dog')
        self._myListbox.insert(END, 'mouseeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee')
        self._myListbox.insert(END, 'rat')
        self._myListbox.insert(END, 'fish')

        xScroll["command"] = self._myListbox.xview
        yScroll["command"] = self._myListbox.yview
        doneButton = Button(self, text='Click when \n done',
                            command=self._readSelections)
        doneButton.grid(row=3)

    def _readSelections(self):
        selectionsTuple = self._myListbox.curselection()
        print selectionsTuple
        print "Favorite Animals:"
        for i in selectionsTuple:
            print i, self._myListbox.get(i)

# end class Application

def main():
    """Instantiate and pop up the window."""
    Application().mainloop()

main()
