# NestedFrameClasses.py
from Tkinter import *
import tkMessageBox

class CountClick(Frame):                    # Extend Frame class
    def __init__(self, parent=None):
        Frame.__init__(self, parent)        # call superclass init
        self.grid()
        self._data = 0
        self._showDataString = StringVar()   # create a String control variable
        self._showDataString.set('Data = %d' % (self._data))
        self._make_widgets()                 # attach widgets to self

        
    def _make_widgets(self):
        """Create GUI widgets and place them in the frame"""
        myButton = Button(self, text='Count Clicks', command=self._message)
        myButton.grid(row = 1, column = 1)
        countLabel = Label(self, textvariable=self._showDataString, 
                           width=50, justify=CENTER)
        countLabel.grid(row = 1, column = 0)

class Hello(Frame):                         # Extend Frame class
    def __init__(self, parent=None):
        Frame.__init__(self, parent)        # call superclass init
        self._top = self.winfo_toplevel()   # find top-level window
        self._top.title("Frame and StringVar Example")
        self.grid()
        self._data = 0
        self._showDataString = StringVar()   # create a String control variable
        self._showDataString.set('Data = %d' % (self._data))
        self._make_widgets()                 # attach widgets to self

        
    def _make_widgets(self):
        """Create GUI widgets and place them in the frame"""
        quitButton = Button(self, text='Quit', command=self._quit)
        quitButton.grid(row=0, column = 1, rowspan=2, sticky=N+S)
        myFrame = Frame(self, borderwidth=10, relief=GROOVE)
        myFrame.grid(row=0, column=0, columnspan=2,rowspan=2)
        myButton = Button(myFrame, text='Count Clicks', command=self._message)
        myButton.grid(row = 1, column = 1)
        countLabel = Label(myFrame, textvariable=self._showDataString, 
                           width=50, justify=CENTER)
        countLabel.grid(row = 1, column = 0)


    def _quit(self):
        print "Quit"
        quitAnswer = tkMessageBox.askokcancel(message='Do you really want to quit?',
                                              parent=self)
        if quitAnswer:
            self._top.quit()
        else:
            print "Quit cancelled"
        
    def _message(self):
        self._data += 1
        self._showDataString.set('Data = %d' % (self._data)) 
# end class Hello(Frame)

def main():
    Hello().mainloop()

main()
